

class DcouponSDKException implements Exception {
  /// The long form message of the exception.
  final String? message;

  /// The optional code to accommodate the message.
  ///
  /// Allows users to identify the exception from a short code-name, for example
  /// "no-sdk" is used when a user attempts to read a [DcouponSDK] which does
  /// not exist.
  final String code;

  DcouponSDKException({
    this.message,
    String? code,
    // ignore: unnecessary_this
  }) : this.code = code ?? 'unknown';
}

DcouponSDKException noSdkInitialized() {
  return DcouponSDKException(
    code: 'no-sdk',
    message:
        "No DcouponSDK has been initialized - call DcouponSDK.initializeSdk()",
  );
}

class ServerException implements Exception {
  final String message;

  ServerException([this.message = '']);

  @override
  String toString() => 'ServerException: $message';
}

class CacheException implements Exception {}
