import 'package:dio/dio.dart';
import 'package:equatable/equatable.dart';

class DcouponSDKOptions extends Equatable {
  /// The environment in which the app is currently configured
  final String clientDomain;

  /// The country in which the app is currently configured
  final String clientCountry;

  /// The client api key for the country
  final String clientApiToken;

  /// The client secret key for the country
  final String clientSecretKey;


  /// The host in which the web is currently running
  final String? webOrigin;

  final List<Interceptor> dioInterceptors;

  const DcouponSDKOptions({
    required this.clientDomain,
    required this.clientCountry,
    required this.clientApiToken,
    required this.clientSecretKey,
    this.webOrigin,
    this.dioInterceptors = const [],
  });

  @override
  List<Object?> get props => [
        clientDomain,
        clientCountry,
        clientApiToken,
        clientSecretKey,
        webOrigin,
        dioInterceptors,
      ];
}
