import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';

abstract class ReceiptRepository {
  Future<Either<Failure, dynamic>> getS3FilePresignedUrl();

  Future<Either<Failure, dynamic>> uploadPresignedUrlFile({
    required List<int> fileBytes,
    required String presignedUrl,
    required Map<String, dynamic> presignedUrlFields,
  });

  Future<Either<Failure, dynamic>> getUserReceipts({
    int? start,
    int? limit,
  });
}
