import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/usecases/usecase.dart';
import 'package:dcoupon_sdk_flutter_package/src/domain/repositories/coupon_repository.dart';
import 'package:equatable/equatable.dart';

class CouponGetAnonymousCouponDetail
    implements UseCase<dynamic, CouponGetAnonymousCouponDetailParams> {
  final CouponRepository repository;

  CouponGetAnonymousCouponDetail(this.repository);

  @override
  Future<Either<Failure, dynamic>> call(
      CouponGetAnonymousCouponDetailParams params) async {
    return await repository.getAnonymousCouponDetail(
      couponId: params.couponId,
    );
  }
}

class CouponGetAnonymousCouponDetailParams extends Equatable {
  final String couponId;

  CouponGetAnonymousCouponDetailParams({
    required this.couponId,
  });

  @override
  List<Object?> get props => [
        couponId,
      ];
}
