import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/usecases/usecase.dart';
import 'package:dcoupon_sdk_flutter_package/src/domain/repositories/receipt_repository.dart';

class ReceiptGetS3PresignedUrl implements UseCase<dynamic, NoParams> {
  final ReceiptRepository repository;

  ReceiptGetS3PresignedUrl(
    this.repository,
  );

  @override
  Future<Either<Failure, dynamic>> call(NoParams params) async {
    return await repository.getS3FilePresignedUrl();
  }
}
