import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/usecases/usecase.dart';
import 'package:dcoupon_sdk_flutter_package/src/domain/repositories/receipt_repository.dart';
import 'package:equatable/equatable.dart';

class ReceiptGetUserReceipts
    implements UseCase<dynamic, ReceiptGetUserReceiptsParams> {
  final ReceiptRepository repository;

  ReceiptGetUserReceipts(this.repository);

  @override
  Future<Either<Failure, dynamic>> call(
      ReceiptGetUserReceiptsParams params) async {
    return await repository.getUserReceipts(
      start: params.start,
      limit: params.limit,
    );
  }
}

class ReceiptGetUserReceiptsParams extends Equatable {
  final int? start;
  final int? limit;

  ReceiptGetUserReceiptsParams({
    this.start,
    this.limit,
  });

  @override
  List<Object?> get props => [
        start,
        limit,
      ];
}
