import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/usecases/usecase.dart';
import 'package:dcoupon_sdk_flutter_package/src/domain/repositories/redemption_repository.dart';
import 'package:equatable/equatable.dart';

class RedemptionGenerateTemporalCouponToken
    implements UseCase<dynamic, RedemptionGenerateTemporalCouponTokenParams> {
  final RedemptionRepository repository;

  RedemptionGenerateTemporalCouponToken(this.repository);

  @override
  Future<Either<Failure, dynamic>> call(
      RedemptionGenerateTemporalCouponTokenParams params) async {
    return await repository.generateTemporalCouponToken(
      couponId: params.couponId,
    );
  }
}

class RedemptionGenerateTemporalCouponTokenParams extends Equatable {
  final String couponId;

  RedemptionGenerateTemporalCouponTokenParams({
    required this.couponId,
  });

  @override
  List<Object?> get props => [
        couponId,
      ];
}
