import 'dart:convert';

import 'package:universal_io/io.dart';

import 'package:dcoupon_sdk_flutter_package/dcoupon_sdk_flutter_package.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    final sdkConfigJson = jsonDecode(new File('test.json').readAsStringSync());
    DcouponSDK.initializeSdk(
        options: DcouponSDKOptions(
      clientDomain: sdkConfigJson['com.dcoupon.sdk.ClientDomain'],
      clientCountry: sdkConfigJson['com.dcoupon.sdk.ClientCountry'],
      clientApiToken: sdkConfigJson['com.dcoupon.sdk.ClientToken'],
      clientSecretKey: sdkConfigJson['com.dcoupon.sdk.ClientSecretKey'],
    ));
    /*dcoupon.setJwt("mocked_jwt");
    dcoupon.setClientType("mocked_clientType");
    dcoupon.setIsLogged(true);*/
  });

  tearDown(() {});

  test('login', () async {
    DcouponSDK.instance.logIn('mocked').then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getCoupons', () async {
    DcouponSDK.instance
        .getCoupons(offset: 0, limit: 0, sortBy: null)
        .then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getCouponDetail', () async {
    DcouponSDK.instance.getCouponDetail(couponId: 0).then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('activateCoupon', () async {
    DcouponSDK.instance.activateCoupon(couponId: 0).then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('deactivateCoupon', () async {
    DcouponSDK.instance.deactivateCoupon(couponId: 0).then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });
  test('getRedemptionCode', () async {
    DcouponSDK.instance.getRedemptionCode().then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('createCoupons', () async {
    DcouponSDK.instance.createCoupons(
      promotionTokens: ['mocked', 'mocked'],
      latitude: null,
      longitude: null,
      saveMethod: null,
      utmSource: null,
      transId: null,
      crmId: null,
      publisherToken: '',
    ).then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getCategories', () async {
    DcouponSDK.instance
        .getCategories(lang: '', publisherToken: '')
        .then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getPromotions', () async {
    DcouponSDK.instance
        .getPromotions(
            start: 0,
            limit: 0,
            categoryIds: null,
            storeIds: null,
            retailerTokens: null,
            companyTokens: null,
            textSearch: null,
            zipcode: null,
            latitude: null,
            longitude: null,
            radius: null,
            orderBy: null,
            publisherToken: '')
        .then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getPromotionDetail', () async {
    DcouponSDK.instance
        .getPromotionDetail(promotionToken: '', publisherToken: '')
        .then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  test('getStores', () async {
    DcouponSDK.instance
        .getStores(
            promotionToken: null,
            start: 0,
            limit: 0,
            retailerTokens: null,
            zipcode: null,
            latitude: null,
            longitude: null,
            radius: null,
            publisherToken: '')
        .then((response) {
      expect(response.code, 400);
    }).catchError((ex) {
      print(ex.toString());
    });
  });

  testWidgets("Empty widget test", (tester) async {});
}
